
   Uses Graph,Types,Crt;

 {.....................................................................}

   Const     MaxRec = 5000;

 {.................................................}

   Type
            PtrData = ^DataRec;
            DataRec = record
                       Lst: Integer;
                       Spd: Single;
                      end;
 {.................................................}

    Var
            Data: array[0..MaxRec] Of PtrData;
            VMax,VJump : Double;

            i,j,k: Integer;

 {---------------------------------------------------------------------}

   Procedure GraphRecord;

 {...............................}
   Label
              BeginSubCh;


 {........................................................................}
   Type

           PicRec  = record
                      T0,T1,
                      D0,D1 : Integer;
                      kT,kD : Double;
                      sT,sD : Integer;
                         kY : Byte;
                     end;

 {........................................................................}
   Const
                    dX = 40;
                    dY = 20;

                  Step = 20;
             CursColor = Brown;
             CursSize  = 8;
             CursInc   = 10;

             MaxPic    = 9;
             kY0       = 4;

 {........................................................................}
   Var
             grDriver : Integer;
             grMode   : Integer;
             ErrCode  : Integer;

             pX0,pY0  : Integer;
             gmX,gmY  : Integer;
             X,Y      : Integer;
             s        : NamStr;

             xc0,yc0  : Integer;
             xc1,yc1  : Integer;
             NormCurs : Boolean;

             xw0,yw0  : Integer;
             WinBegin : Boolean;

             Active   : Byte;
             Value    : Byte;
             Pic      : array[0..MaxPic] Of PicRec;

 {........................................................................}

   Procedure grCursor(Moving: Byte);
   begin
    SetWriteMode(XORPut); SetColor(CursColor);
    if NormCurs then
    begin
     if Moving =1 then
     begin
      Line(xc0-CursSize,yc0,xc0+CursSize,yc0);
      Line(xc0,yc0-CursSize,xc0,yc0+CursSize);
     end;
     Line(xc1-CursSize,yc1,xc1+CursSize,yc1);
     Line(xc1,yc1-CursSize,xc1,yc1+CursSize);
    end else
    begin
     if Moving =1  then
     begin
      Line(dX,yc0,gmX,yc0);
      Line(xc0,dY,xc0,gmY);
     end;
      Line(dX,yc1,gmX,yc1);
      Line(xc1,dY,xc1,gmY);
    end;

    if WinBegin then
    begin
     SetColor(LightRed);
     if (xw0 =xc0) Or (yw0 =yc0) then
     Line(xw0,yw0,xc0,yc0) else Rectangle(xw0,yw0,xc0,yc0);
     if (xw0 =xc1) Or (yw0 =yc1) then
     Line(xw0,yw0,xc1,yc1) else Rectangle(xw0,yw0,xc1,yc1);
    end;

    SetWriteMode(NormalPut);
    xc0:=xc1; yc0:=yc1;
   end;

 {........................................................................}

   Procedure View(NewPic: Byte);
   begin With Pic[Active] do
   begin

    if NewPic> 0 then
    begin
     i:=(T1-T0) Div 5; k:=10000; While i Div k =0 do k:=k Div 10;
     T0:=(T0 Div k)*k; sT:=Round((T1-T0)/(k*5))*k; kT:=100/sT;
     T1:=T0+sT*5; if T1> MaxRec then T1:=MaxRec;

     D0:=MaxInt; D1:=-D0; for i:=T0 to T1 do
     begin
      j:=Data[i]^.Lst;
      if j <D0 then D0:=j else
      if j> D1 then D1:=j;
     end;
     D0:=D0*kY; D1:=D1*kY;
     i:=(D1-D0) Div 4; k:=10000; While i Div k =0 do k:=k Div 10;
     D0:=(D0 Div k)*k; sD:=Round((D1-D0)/(k*4))*k; kD:=100/sD;
    end;

    ClearViewPort;
    SetColor(White); Rectangle(dX,dY,gmX,gmY);

    i:=pX0; j:=gmY+4; k:=T0; While i <gmX do
    begin
     Line(i,gmY,i,j); Str(k:4,s); OutTextXY(i-16,gmY+8,s);
     Inc(i,100); k:=k+sT;
    end;
    i:=pY0; j:=dX-4; k:=D0; While i <gmY do
    begin
     Line(dX,i,j,i); Str(k:4,s); OutTextXY(0,i,s);
     Dec(i,100); k:=k+sD;
    end;
    SetColor(DarkGray);
    i:=dX+step; While i <gmX do begin Line(i,dY,i,gmY); Inc(i,step); end;
    i:=dY+step; While i <gmY do begin Line(dX,i,gmX,i); Inc(i,step); end;

    SetColor(White);


    SetTextStyle( 8, HorizDir, 3);
    OutTextXY(100,40,'0123456789');
    PutPixel(100,60,14);




    MoveTo(pX0,pY0-Round((Data[i]^.Lst-D0)*kD));
    for i:=Succ(T0) to T1 do
    begin
     X:=pX0+Round((i-T0)*kT);
     Y:=pY0-Round((Data[i]^.Lst-D0)*kD);
     LineTo(X,Y);
    end;

    grCursor(0); WinBegin:=False;
   end;
   end;

 {........................................................................}

   Begin
    grDriver := Detect;
    InitGraph(grDriver, grMode,'');
    ErrCode := GraphResult;
    if ErrCode = grOk then
    begin
     SetTextStyle(SmallFont,HorizDir,4);
     DirectVideo:=False;

     gmX:=GetMaxX-dX; gmY:=GetMaxY-dY;
     pX0:=dX+step; pY0:=gmY-step;
     xc1:=pX0; yc1:=pY0;
     NormCurs:=True; WinBegin:=False;

     Active:=0; Value:=0;
     With Pic[0] do begin T0:=0; T1:=MaxRec; kY:=kY0; end;

     View(1);
     Repeat


  {........................................................................}
  {Table}

      if KeyPressed then
      begin
       ChMain:=ReadKey;
       Case ChMain Of
 NUL:   begin
         SubCh:=ReadKey;

         BeginSubCh:
         Case SubCh Of
  {........................................................................}
  {Cursor}

     #75: if ExtendKey and 3> 0 then
          if xc1 <=dX then else Dec(xc1) else
          if xc1> dX+CursInc then Dec(xc1,CursInc) else xc1:=dX;
     #77: if ExtendKey and 3> 0 then
          if xc1 >=gmX then else Inc(xc1) else
          if xc1 <gmX-CursInc then Inc(xc1,CursInc) else xc1:=gmX;
     #72: if ExtendKey and 3> 0 then
          if yc1 <=dY then else Dec(yc1) else
          if yc1> dY+CursInc then Dec(yc1,CursInc) else yc1:=dY;
     #80: if ExtendKey and 3> 0 then
          if yc1 >=gmY then else Inc(yc1) else
          if yc1 <gmY-CursInc then Inc(yc1,CursInc) else yc1:=gmY;
     #82: begin grCursor(0); NormCurs:=not NormCurs; grCursor(0); end;

  {........................................................................}
  {Command}
  {........................................................................}

    #115: if Active> 0 then begin Dec(Active); View(0); end;
    #116: if Active <Value then begin Inc(Active); View(0); end;
    #130: With Pic[Active] do
          if kY <16 then begin kY:=kY*2; View(1); end;
    #131: With Pic[Active] do
          if kY> 1 then begin kY:=kY Div 2; View(1); end;
         end;
         if (xc1 <>xc0) Or (yc1 <>yc0) then grCursor(1);
        end;
  {........................................................................}
  {Windows}

   SEL: if WinBegin then
        begin
         With Pic[Active] do
         begin
          i:=Round(T0+(xw0-pX0)/kT);
          j:=Round(T0+(xc0-pX0)/kT);
         end;
         if Abs(i-j) <6 then
         begin k:=(i+j) Div 2; i:=k+4; j:=k-4; end;
         if Value <MaxPic then Inc(Value)
         else Move(Pic[2],Pic[1],Pred(MaxPic)*SizeOf(PicRec));
         Active:=Value; With Pic[Active] do
         begin
          if i> j then begin T0:=j; T1:=i; end
          else begin T0:=i; T1:=j; end;
          kY:=kY0; View(1);
          PS:=0; Write(T0:8,T1:8);
         end;
        end
        else begin xw0:=xc0; yw0:=yc0; WinBegin:=True; end;

 ENT:   View(0);
       end;
      end;

     Until ChMain =ESC;
     CloseGraph; SubCh:=NUL;
    end
    else Writeln('Graphics error:', GraphErrorMsg(ErrCode));
   End;

 {.....................................................................}

  Begin
   for i:=0 to MaxRec do
   begin
    New(Data[i]);
    With Data[i]^ do
    begin
     Lst:=Integer(Random(120))-50;
     Spd:=100;
    end;
   end;

 {.......................................................}

   GraphRecord;
  End.
