  Uses Crt;
  Type
           PtrFont = ^TFont;
           TFont = array[0..4,0..3] of Char;

   {....................................................}

           PtrPoke = ^PokeRec;
           PokeRec = record
                      Ch: Char;
                      Cl: Byte;
                     end;

   {....................................................}

           PtrVideo   = ^VideoArr;
           VideoArr   = array[0..24,0..79] of PokeRec;

   {....................................................}

  Const

         GD = #219;
         GU = #219;
         VL = #221;
         VR = #222;
         SL = #32;

         _0: TFont =
         ((GD,GD,GD,GD),
          (GU,SL,SL,GU),
          (GU,SL,SL,GU),
          (GU,SL,SL,GU),
          (GU,GU,GU,GU));

         _1: TFont =
         ((SL,SL,GD,GD),
          (SL,SL,GD,GD),
          (SL,SL,SL,GD),
          (SL,SL,SL,GD),
          (SL,SL,SL,GD));

         _2: TFont =
         ((GU,GU,GU,GU),
          (SL,SL,SL,VR),
          (GU,GU,GU,GU),
          (VL,SL,SL,SL),
          (GD,GD,GD,GD));

         _3: TFont =
         ((GU,GU,GU,GU),
          (SL,SL,SL,VR),
          (GU,GU,GU,GU),
          (SL,SL,SL,VR),
          (GD,GD,GD,GD));

         _4: TFont =
         ((GU,SL,SL,GU),
          (GU,SL,SL,GU),
          (GU,GU,GU,GU),
          (SL,SL,SL,GU),
          (SL,SL,SL,GU));

         _5: TFont =
         ((GU,GU,GU,GU),
          (VL,SL,SL,SL),
          (GU,GU,GU,GU),
          (SL,SL,SL,VR),
          (GD,GD,GD,GD));

         _6: TFont =
         ((GU,GU,GU,GU),
          (VL,SL,SL,SL),
          (GU,GU,GU,GU),
          (VL,SL,SL,VR),
          (GD,GD,GD,GD));

         _7: TFont =
         ((GU,GU,GU,GU),
          (SL,SL,SL,GU),
          (SL,SL,SL,GU),
          (SL,SL,SL,GU),
          (SL,SL,SL,GU));

         _8: TFont =
         ((GU,GU,GU,GU),
          (VL,SL,SL,VR),
          (GU,GU,GU,GU),
          (VL,SL,SL,VR),
          (GD,GD,GD,GD));

         _9: TFont =
         ((GU,GU,GU,GU),
          (VL,SL,SL,VR),
          (GU,GU,GU,GU),
          (SL,SL,SL,VR),
          (GD,GD,GD,GD));

          _T: TFont =
         ((SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,GD,GD,SL));

          _S: TFont =
         ((SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,SL,SL,SL),
          (SL,SL,SL,SL));

   Var

          Video: VideoArr absolute $B800:0;
              S: String;
              D: Double;
              P: Double;
            Key: Char;
          i,j,k: Byte;

   Procedure WriteBigChar(x,y: Byte; C: Char);
   var Fnt: PtrFont;
   Begin
    Case C Of

             ' ': Fnt:=@_S;
             '.': Fnt:=@_T;
        '0'..'9': begin Fnt:=@_0; Inc(Fnt,Ord(C)-48); end;
    end;

    for j:=0 to 4 do
    for i:=0 to 3 do
    With Video[y+j,x+i] do
    begin
     Cl:=TextAttr;
     Ch:=Fnt^[j,i];
    end;
   End;

   Procedure WriteBigStr(x,y: Byte; D: Double);
   Begin
    Str(D:11:3,S);
    for k:=1 to Length(S) do WriteBigChar(x+k*5,y,S[k]);
   End;


  Begin


   ClrScr;
   TextAttr:=$0E;

   WriteBigChar(05,0,' ');
   WriteBigChar(05,5,'0');
   WriteBigChar(10,5,'1');
   WriteBigChar(15,5,'2');
   WriteBigChar(20,5,'3');
   WriteBigChar(25,5,'.');
   WriteBigChar(30,5,'4');
   WriteBigChar(35,5,'5');
   WriteBigChar(40,5,'6');
   WriteBigChar(45,5,'7');
   WriteBigChar(50,5,'8');
   WriteBigChar(55,5,'9');
   GotoXY(5,25); Write('0 1 2 3 4 5 6 7 8 9');

   readln;
   ClrScr;
   TextAttr:=$0E;

   repeat
    D:=Random(2455);
    P:=Random(2955);
    WriteBigStr(0,2,P*D/1000);
    D:=Random(2455);
    P:=Random(2955);
    WriteBigStr(0,10,P*D/1000);
    D:=Random(2455);
    P:=Random(2955);
    WriteBigStr(0,18,P*D/1000);
   { Key:=ReadKey;}
    Delay(60000);
   until KeyPressed;
  End.
