
   Uses Graph,Types,Crt;

 {.....................................................................}

   Const     MaxRec = 5000;

 {.................................................}

   Type
            PtrData = ^DataRec;
            DataRec = record
                       Lst: Integer;
                       Spd: Integer;
                      end;
 {.................................................}

    Var
            Data: array[0..MaxRec] Of PtrData;
            VMax,VJump : Double;

               PS: Word Absolute $0040:$0050;
            i,j,k: Integer;

 {---------------------------------------------------------------------}

   Procedure GraphRecord;

 {...............................}
   Label
              BeginSubCh;


 {........................................................................}
   Type

           PicRec  = record
                      T0,T1,
                      D0,D1 : Integer;
                      kT,kD : Double;
                      sT,sD : Integer;
                     end;

 {........................................................................}
   Const
                   dX = 40;
                   dY = 20;
                  gX0 = 40;
                  gY0 = 40;

                MaxPic = 9;
                  Step = 20;
                   kY0 = 4;

             CursColor = Brown;
             CursSize  = 8;
             CursInc   = 10;

 {........................................................................}
   Var
             grDriver : Integer;
             grMode   : Integer;
             ErrCode  : Integer;

             pX0,pY0  : Integer;
             gmX,gmY  : Integer;
             X,Y      : Integer;
             kY       : Byte;
             F0,F1,
             pF0,sF   : Integer;
             kF       : Double;
             s        : NamStr;

             xc0,yc0  : Integer;
             xc1,yc1  : Integer;
             NormCurs : Boolean;

             xw0,yw0  : Integer;
             WinBegin : Boolean;

             Active   : Byte;
             Value    : Byte;
             Pic      : array[0..MaxPic] Of PicRec;

 {........................................................................}

   Procedure grCursor(Moving: Byte);
   begin
    SetWriteMode(XORPut); SetColor(CursColor);
    if NormCurs then
    begin
     if Moving =1 then
     begin
      Line(xc0-CursSize,yc0,xc0+CursSize,yc0);
      Line(xc0,yc0-CursSize,xc0,yc0+CursSize);
     end;
     Line(xc1-CursSize,yc1,xc1+CursSize,yc1);
     Line(xc1,yc1-CursSize,xc1,yc1+CursSize);
    end else
    begin
     if Moving =1  then
     begin
      Line(gX0,yc0,gmX,yc0);
      Line(xc0,gY0,xc0,gmY);
     end;
      Line(gX0,yc1,gmX,yc1);
      Line(xc1,gY0,xc1,gmY);
    end;

    if WinBegin then
    begin
     SetColor(LightRed);
     if (xw0 =xc0) Or (yw0 =yc0) then
     Line(xw0,yw0,xc0,yc0) else Rectangle(xw0,yw0,xc0,yc0);
     if (xw0 =xc1) Or (yw0 =yc1) then
     Line(xw0,yw0,xc1,yc1) else Rectangle(xw0,yw0,xc1,yc1);
    end;

    SetWriteMode(NormalPut);
    xc0:=xc1; yc0:=yc1;

    With Pic[Active] do
    begin
     PS:=$0130; TextAttr:=$0F; Write('T ');
     TextAttr:=$07; Write(T0+Round((xc0-pX0)/kT)); Write(' ':55-WhereX);
     PS:=$013A; TextAttr:=$0F; Write('D ');
     TextAttr:=$07; Write(Round((yc0-pY0)/kD)); Write(' ':65-WhereX);
    end;
   end;

 {........................................................................}

    Function GetScale(Item: Integer): Integer;
    var
         k,Scale: LongInt;

    Begin
     k:=1;
     repeat
      Scale:=10*k;
      if Scale> Item then Break;
      Scale:=25*k;
      if Scale> Item then Break;
      Scale:=50*k;
      if Scale> Item then Break;
      Scale:=75*k;
      if Scale> Item then Break;
      k:=k*10;
     until k >5000;
     GetScale:=Scale;
    End;
 {........................................................................}

   Procedure View(NewPic: Byte);
   begin With Pic[Active] do
   begin

    if NewPic> 0 then
    begin
     i:=(T1-T0) Div 5; k:=10000; While i Div k =0 do k:=k Div 10;
     T0:=(T0 Div k)*k; sT:=Round((T1-T0)/(k*5))*k; kT:=100/sT;
     T1:=T0+sT*5; if T1> MaxRec then T1:=MaxRec;

     D0:=0; D1:=0; for i:=T0 to T1 do
     begin
      j:=Abs(Data[i]^.Lst);
      if j> D1 then D1:=j;
     end;
     if D1 =D0 then D1:=2; D1:=D1*kY;
     sD:=GetScale(D1 Div 2); kD:=100/sD;
     F1:=F0*kY Div kY0;
     sF:=GetScale(F1 Div 4); kF:=100/sF;
    end;

    ClearViewPort;
    SetColor(White); Rectangle(gX0,gY0,gmX,gmY);

    i:=pX0; k:=T0; While i <gmX do
    begin
     Line(i,gmY,i,gmY+4); Str(k:4,s); OutTextXY(i-16,gmY+8,s);
     Inc(i,100); Inc(k,sT);
    end;
    i:=pY0+200; k:=-2*sD; j:=0; While i> gY0 do
    begin
     Line(gX0,i,gX0-4,i); Str(k:4,s); OutTextXY(0,i,s);
     Line(gmX,i,gmX+4,i); Str(j,s); OutTextXY(gmX+12,i,s);
     Dec(i,100); Inc(k,sD); Inc(j,sF);
    end;

    SetColor(DarkGray);
    i:=gX0+Step; While i <gmX do begin Line(i,gY0,i,gmY); Inc(i,Step); end;
    i:=pY0; While i <gmY do begin Line(gX0,i,gmX,i); Inc(i,Step); end;
    i:=pY0-Step; While i> gY0 do begin Line(gX0,i,gmX,i); Dec(i,Step); end;

    SetColor(LightGreen);
    MoveTo(pX0,pY0-Round(Data[T0]^.Lst*kD));
    for i:=Succ(T0) to T1 do
    begin
     X:=pX0+Round((i-T0)*kT);
     Y:=pY0-Round(Data[i]^.Lst*kD);
     LineTo(X,Y);
    end;
    SetColor(LightCyan);
    MoveTo(pX0,pF0-Round(Data[T0]^.Spd*kF));
    for i:=Succ(T0) to T1 do
    begin
     X:=pX0+Round((i-T0)*kT);
     Y:=pF0-Round(Data[i]^.Spd*kF);
     LineTo(X,Y);
    end;

    grCursor(0); WinBegin:=False;
   end;
   end;

 {........................................................................}

   Begin
    grDriver := Detect;
    InitGraph(grDriver, grMode,'');
    ErrCode := GraphResult;
    if ErrCode = grOk then
    begin
     SetTextStyle(SmallFont,HorizDir,4);
     DirectVideo:=False;

     gmX:=GetMaxX-dX; gmY:=GetMaxY-dY;
     pX0:=gX0+Step; pY0:=(gY0+gmY) Div 2;
     xc1:=pX0; yc1:=pY0; kY:=kY0;
     NormCurs:=True; WinBegin:=False;

     F0:=0; for i:=0 to MaxRec do
     begin
      j:=Abs(Data[i]^.Spd);
      if j> F0 then F0:=j;
     end;
     if F0 =0 then F0:=25; F1:=F0; pF0:=pY0+200;

     Active:=0; Value:=0;
     With Pic[0] do begin T0:=0; T1:=MaxRec; end;

     View(1);
     Repeat


  {........................................................................}
  {Table}

      if KeyPressed then
      begin
       ChMain:=ReadKey;
       Case ChMain Of
 NUL:   begin
         SubCh:=ReadKey;

         BeginSubCh:
         Case SubCh Of
  {........................................................................}
  {Cursor}

     #75: if ExtendKey and 3> 0 then
          if xc1 <=gX0 then else Dec(xc1) else
          if xc1> gX0+CursInc then Dec(xc1,CursInc) else xc1:=gX0;
     #77: if ExtendKey and 3> 0 then
          if xc1 >=gmX then else Inc(xc1) else
          if xc1 <gmX-CursInc then Inc(xc1,CursInc) else xc1:=gmX;
     #72: if ExtendKey and 3> 0 then
          if yc1 <=gY0 then else Dec(yc1) else
          if yc1> gY0+CursInc then Dec(yc1,CursInc) else yc1:=gY0;
     #80: if ExtendKey and 3> 0 then
          if yc1 >=gmY then else Inc(yc1) else
          if yc1 <gmY-CursInc then Inc(yc1,CursInc) else yc1:=gmY;
     #82: begin grCursor(0); NormCurs:=not NormCurs; grCursor(0); end;

  {........................................................................}
  {Command}
  {........................................................................}

    #115: if Active> 0 then begin Dec(Active); View(0); end;
    #116: if Active <Value then begin Inc(Active); View(0); end;
    #130: With Pic[Active] do
          if kY <16 then begin kY:=kY*2; View(1); end;
    #131: With Pic[Active] do
          if kY> 1 then begin kY:=kY Div 2; View(1); end;
         end;
         if (xc1 <>xc0) Or (yc1 <>yc0) then grCursor(1);
        end;
  {........................................................................}
  {Windows}

   SEL: if WinBegin then
        begin
         With Pic[Active] do
         begin
          i:=Round(T0+(xw0-pX0)/kT);
          j:=Round(T0+(xc0-pX0)/kT);
         end;
         if Abs(i-j) <6 then
         begin k:=(i+j) Div 2; i:=k+4; j:=k-4; end;
         if Value <MaxPic then Inc(Value)
         else Move(Pic[2],Pic[1],Pred(MaxPic)*SizeOf(PicRec));
         Active:=Value; With Pic[Active] do
         begin
          if i> j then begin T0:=j; T1:=i; end
          else begin T0:=i; T1:=j; end;
          if T0 <0 then T0:=0;
          if T1> MaxRec then T1:=MaxRec;
          View(1);
         end;
        end
        else begin xw0:=xc0; yw0:=yc0; WinBegin:=True; end;

 ENT:   View(0);
       end;
      end;

     Until ChMain =ESC;
     CloseGraph; SubCh:=NUL;
    end
    else Writeln('Graphics error:', GraphErrorMsg(ErrCode));
   End;

 {.....................................................................}

  Begin
   for i:=0 to MaxRec do
   begin
    New(Data[i]);
    With Data[i]^ do
    begin
     Lst:=Integer(Random(55))-50;
     if i> 175 then Spd:=Data[i-1]^.Spd else Spd:=LongInt(i)*i Div 100;
    end;
   end;

 {.......................................................}

   GraphRecord;
  End.
