
unit BGI;

interface

procedure SansFont;
procedure LittFont;
procedure BoldFont;
procedure TscrFont;

{
procedure TripFont;
procedure EgaVgaDriver;
procedure EuroFont;
procedure LComFont;
procedure ScriFont;
procedure SimpFont;
}

implementation
uses Graph;
var  nReg: Integer;


procedure SansFont; external;
{$L SANS.OBJ }
procedure LittFont; external;
{$L LITT.OBJ }
procedure BoldFont; external;
{$L BOLD.OBJ }
procedure TscrFont; external;
{$L TSCR.OBJ }

(*
procedure EgaVgaDriver; external;
{$L EGAVGA.OBJ }
procedure TripFont; external;
{$L TRIP.OBJ }
procedure EuroFont; external;
{$L EURO.OBJ }
procedure LComFont; external;
{$L LCOM.OBJ }
procedure ScriFont; external;
{$L SCRI.OBJ }
procedure SimpFont; external;
{$L SIMP.OBJ }
procedure GothFont; external;
{$L GOTH.OBJ }
*)

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

begin
{
  nReg:=RegisterBGIdriver(@EGAVGADriver);
  if nReg <0 then Abort('EGA/VGA') else WriteLn('Driver =',nReg);
  nReg:=RegisterBGIfont(@TripFont);
  if nReg <0 then Abort('TripFont') else WriteLn('Trip =',nReg);
}
  nReg:=RegisterBGIfont(@SansFont);
  if nReg <0 then Abort('SansFont') else WriteLn('Sans =',nReg);
  nReg:=RegisterBGIfont(@LittFont);
  if nReg <0 then Abort('LittFont') else WriteLn('Litt =',nReg);
  nReg:=RegisterBGIfont(@BoldFont);
  if nReg <0 then Abort('BoldFont') else WriteLn('Bold =',nReg);
  nReg:=RegisterBGIfont(@TscrFont);
  if nReg <0 then Abort('TscrFont') else WriteLn('Tscr =',nReg);
end.
