
  Unit INT8;


  Interface
  Var
               PS: Word Absolute $0040:$0050;
               T0: LongInt Absolute $0040:$006C;

               Flag: Boolean;
               IRQ : Pointer;

   Procedure Freq(f: Word);
   Procedure Time; interrupt;
   Procedure Done;

   Implementation
   Uses Dos;

{-----------------------------------------------------------------------}

   Procedure Freq(f: Word);
   Begin
    if f> 0 then f:=1193180 div f;
    Port[$43]:=$36; Port[$40]:=Lo(f); Port[$40]:=Hi(f);
   End;

{-----------------------------------------------------------------------}

   Procedure Time;
   begin
    PS:=$0038; Write(T0,'    ');
    Flag:=True;
   end;

{-----------------------------------------------------------------------}

   Procedure Done;
   begin
    Freq(0);
    SetIntVec($1C,IRQ);
   end;

{-----------------------------------------------------------------------}


   Begin
    GetIntVec($1C,IRQ);
  {  Freq(500); }
    SetIntVec($1C,@Time);
   End.

