
  Program UART;
  Uses Crt;
  Label Stop;

  Const {........................................................}

          COM  = $03f8;
          Rate = $0003;

          RD  = COM;
          RI  = COM+1;
          RC  = COM+3;
          RS  = COM+5;

          RCI = COM+2;
          RCM = COM+4;
          RSM = COM+6;

          NUL = #0;
          ESC = #27;
          ENT = #13;
          SEL = #32;

  Var {..........................................................}

          C0,C1  : Char;
          T      : LongInt;
          Status : Byte;
          S      : String;
          i,Len  : LongInt;

          T0: LongInt absolute $0040:$006C;
          PS: Word absolute $0040:$0050;

          Buf: String;
  {..............................................................}


    Begin

     Port[RC]:=$80;
     Port[RI]:=Hi(Rate);
     Port[RD]:=Lo(Rate);
     Port[RC]:=$03;
     Port[RI]:=0;

     Port[RCM]:=0;
     ClrScr;
     WriteLn(' Enter'); ReadLn;

     Repeat

      Status:=Port[RS];
      PS:=$0200; for i:=0 to 7 do Write(Status shr i and 1);
      if Status> $7f then
      begin GotoXY(1,6); WriteLn(' 裡.'); goto Stop; end;

   {........................................................}
   {Receive}

      if Status and 1> 0 then
      begin
       GotoXY(1,4); ClrEol;
       repeat
        if Status and 1> 0 then
        begin
         if Status and $0E> 0 then
         begin GotoXY(1,6); WriteLn('訡 ਥ.'); goto Stop; end;
         C1:=Char(Port[COM]);
         Write(C1);
        end;
        Status:=Port[RS];
       until C1 =ENT;
      end;

   {........................................................}
   {Transmit}

      if KeyPressed then C0:=ReadKey;
      if C0 =SEL then
      begin
       GotoXY(1,5); ClrEol;
       Len:=10000; i:=1;
       While i <=Len do
       begin
        if i <Len then Port[COM]:=48 else Port[COM]:=13;
        T:=T0;
        repeat
         Status:=Port[RS];
        until (Status =$20) or (Abs(T0-T)> 20);
        if Status <>$20 then
        begin GotoXY(1,6); WriteLn('訡 ।.'); goto Stop; end;
        Inc(i);
       end;
       C0:=NUL;
      end;

   {........................................................}

     Until C0 =ESC;
     Stop:
     GotoXY(1,7); WriteLn(' 裡.');
     Port[RS]:=$0;

    End.